package com.rjconsultores.ventaboletos.web.utilerias.render;

import java.text.SimpleDateFormat;

import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;

import com.rjconsultores.ventaboletos.entidad.ConfRestricaoCanalVenta;

public class RenderConfRestricaoCanalVenta implements ListitemRenderer {

	private SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");

	public void render(Listitem lstm, Object o) throws Exception {
		ConfRestricaoCanalVenta confRestricaoCanalVenta = (ConfRestricaoCanalVenta) o;

		Listcell lc = new Listcell();

		lc = new Listcell(confRestricaoCanalVenta.getConfRestricaoCanalVentaId().toString() == null ? "-" : confRestricaoCanalVenta.getConfRestricaoCanalVentaId().toString());
		lc.setParent(lstm);
		
		lc = new Listcell(confRestricaoCanalVenta.getRuta() == null ? "-" : MyComboRutaRenderer.buscarDescricaoComboRuta(confRestricaoCanalVenta.getRuta()));
		lc.setParent(lstm);

		lc = new Listcell(confRestricaoCanalVenta.getDescConfRestricaoCanalVenta() == null ? "-" : confRestricaoCanalVenta.getDescConfRestricaoCanalVenta());
		lc.setParent(lstm);

		lc = new Listcell(confRestricaoCanalVenta.getCorridaId() == null ? "-" : confRestricaoCanalVenta.getCorridaId().toString());
		lc.setParent(lstm);

		lc = new Listcell(confRestricaoCanalVenta.getFecCorrida() == null ? "-" : sdf.format(confRestricaoCanalVenta.getFecCorrida()));
		lc.setParent(lstm);
		
		lc = new Listcell(buscarDescricaoVigencia(confRestricaoCanalVenta));
		lc.setParent(lstm);

		lstm.setAttribute("data", confRestricaoCanalVenta);
	}

	private String buscarDescricaoVigencia(ConfRestricaoCanalVenta confRestricaoCanalVenta) {
		if(confRestricaoCanalVenta.getFeciniciovigencia()!= null || confRestricaoCanalVenta.getFecfinvigencia()!= null) {
			return "De "+ sdf.format(confRestricaoCanalVenta.getFeciniciovigencia()) + " At " +  sdf.format(confRestricaoCanalVenta.getFecfinvigencia());
		}
		return " - ";
	}

}
